
_dht11_init:

;DHT11.c,17 :: 		void dht11_init( void )
;DHT11.c,19 :: 		TOUT = 0;
	CLRF        DHT11_TOUT+0 
;DHT11.c,20 :: 		T1CON = 0x00;   // Turn-On the Timer when required
	CLRF        T1CON+0 
;DHT11.c,21 :: 		TMR1IF_bit = 0;
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;DHT11.c,22 :: 		TMR1H = 0xFF;   // Load Values for 10us
	MOVLW       255
	MOVWF       TMR1H+0 
;DHT11.c,23 :: 		TMR1L = 0x88;
	MOVLW       136
	MOVWF       TMR1L+0 
;DHT11.c,24 :: 		TMR1IE_bit = 1; // Enable Timer Interrupt
	BSF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
;DHT11.c,25 :: 		INTCON = 0xC0;
	MOVLW       192
	MOVWF       INTCON+0 
;DHT11.c,26 :: 		}
L_end_dht11_init:
	RETURN      0
; end of _dht11_init

_dht11_int_handler:

;DHT11.c,28 :: 		void dht11_int_handler( void )
;DHT11.c,30 :: 		TMR1IF_bit = 0; // Clear Flag
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
;DHT11.c,31 :: 		TMR1H = 0xFF;   // Reload Values
	MOVLW       255
	MOVWF       TMR1H+0 
;DHT11.c,32 :: 		TMR1L = 0x88;
	MOVLW       136
	MOVWF       TMR1L+0 
;DHT11.c,33 :: 		TOUT++;
	INCF        DHT11_TOUT+0, 1 
;DHT11.c,34 :: 		}
L_end_dht11_int_handler:
	RETURN      0
; end of _dht11_int_handler

_dht11_start_measurement:

;DHT11.c,36 :: 		uint8_t dht11_start_measurement( void )
;DHT11.c,38 :: 		uint8_t error = DHT11_NO_ERROR;
	CLRF        dht11_start_measurement_error_L0+0 
;DHT11.c,40 :: 		start_signal();
	CALL        _start_signal+0, 0
;DHT11.c,41 :: 		check = check_response();
	CALL        _check_response+0, 0
;DHT11.c,42 :: 		if( check != DHT11_NO_ERROR )
	MOVF        R0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_dht11_start_measurement0
;DHT11.c,44 :: 		error = DHT11_NO_RESPONSE;
	MOVLW       1
	MOVWF       dht11_start_measurement_error_L0+0 
;DHT11.c,45 :: 		UART1_Write_Text("Response Error\r\n");
	MOVLW       ?lstr1_DHT11+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_DHT11+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;DHT11.c,46 :: 		}
	GOTO        L_dht11_start_measurement1
L_dht11_start_measurement0:
;DHT11.c,49 :: 		checksum = 0;
	CLRF        dht11_start_measurement_checksum_L0+0 
;DHT11.c,50 :: 		error = read_bytes();
	CALL        _read_bytes+0, 0
	MOVF        R0, 0 
	MOVWF       dht11_start_measurement_error_L0+0 
;DHT11.c,51 :: 		for( i=0; i<4; i++ )
	CLRF        dht11_start_measurement_i_L0+0 
L_dht11_start_measurement2:
	MOVLW       4
	SUBWF       dht11_start_measurement_i_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_dht11_start_measurement3
;DHT11.c,53 :: 		checksum = checksum + temp[i];
	MOVLW       DHT11_temp+0
	MOVWF       FSR2 
	MOVLW       hi_addr(DHT11_temp+0)
	MOVWF       FSR2H 
	MOVF        dht11_start_measurement_i_L0+0, 0 
	ADDWF       FSR2, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR2H, 1 
	MOVF        POSTINC2+0, 0 
	ADDWF       dht11_start_measurement_checksum_L0+0, 1 
;DHT11.c,51 :: 		for( i=0; i<4; i++ )
	INCF        dht11_start_measurement_i_L0+0, 1 
;DHT11.c,54 :: 		}
	GOTO        L_dht11_start_measurement2
L_dht11_start_measurement3:
;DHT11.c,55 :: 		if( checksum == temp[4] )
	MOVF        dht11_start_measurement_checksum_L0+0, 0 
	XORWF       DHT11_temp+4, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_dht11_start_measurement5
;DHT11.c,58 :: 		humidity = temp[0];
	MOVF        DHT11_temp+0, 0 
	MOVWF       DHT11_humidity+0 
;DHT11.c,59 :: 		temperature = temp[2];
	MOVF        DHT11_temp+2, 0 
	MOVWF       DHT11_temperature+0 
;DHT11.c,60 :: 		}
	GOTO        L_dht11_start_measurement6
L_dht11_start_measurement5:
;DHT11.c,63 :: 		error = DHT11_CHECKSUM_ERROR;
	MOVLW       2
	MOVWF       dht11_start_measurement_error_L0+0 
;DHT11.c,64 :: 		}
L_dht11_start_measurement6:
;DHT11.c,65 :: 		}
L_dht11_start_measurement1:
;DHT11.c,66 :: 		return error;
	MOVF        dht11_start_measurement_error_L0+0, 0 
	MOVWF       R0 
;DHT11.c,67 :: 		}
L_end_dht11_start_measurement:
	RETURN      0
; end of _dht11_start_measurement

_dht11_temperature:

;DHT11.c,69 :: 		uint8_t dht11_temperature( void )
;DHT11.c,71 :: 		return temperature;
	MOVF        DHT11_temperature+0, 0 
	MOVWF       R0 
;DHT11.c,72 :: 		}
L_end_dht11_temperature:
	RETURN      0
; end of _dht11_temperature

_dht11_humidity:

;DHT11.c,74 :: 		uint8_t dht11_humidity( void )
;DHT11.c,76 :: 		return humidity;
	MOVF        DHT11_humidity+0, 0 
	MOVWF       R0 
;DHT11.c,77 :: 		}
L_end_dht11_humidity:
	RETURN      0
; end of _dht11_humidity

_start_signal:

;DHT11.c,79 :: 		void start_signal( void )
;DHT11.c,81 :: 		DataDir = 0;     // Data port is output
	BCF         TRISB2_bit+0, BitPos(TRISB2_bit+0) 
;DHT11.c,82 :: 		Data    = 0;
	BCF         RB2_bit+0, BitPos(RB2_bit+0) 
;DHT11.c,83 :: 		Delay_ms(25);
	MOVLW       2
	MOVWF       R11, 0
	MOVLW       134
	MOVWF       R12, 0
	MOVLW       153
	MOVWF       R13, 0
L_start_signal7:
	DECFSZ      R13, 1, 1
	BRA         L_start_signal7
	DECFSZ      R12, 1, 1
	BRA         L_start_signal7
	DECFSZ      R11, 1, 1
	BRA         L_start_signal7
;DHT11.c,84 :: 		Data    = 1;
	BSF         RB2_bit+0, BitPos(RB2_bit+0) 
;DHT11.c,85 :: 		Delay_us(30);
	MOVLW       119
	MOVWF       R13, 0
L_start_signal8:
	DECFSZ      R13, 1, 1
	BRA         L_start_signal8
	NOP
	NOP
;DHT11.c,86 :: 		DataDir = 1;     // Data port is input
	BSF         TRISB2_bit+0, BitPos(TRISB2_bit+0) 
;DHT11.c,87 :: 		}
L_end_start_signal:
	RETURN      0
; end of _start_signal

_check_response:

;DHT11.c,89 :: 		uint8_t check_response( void )
;DHT11.c,91 :: 		uint8_t error = DHT11_NO_ERROR;
	CLRF        check_response_error_L0+0 
	CLRF        check_response_counter_L0+0 
;DHT11.c,94 :: 		while( Data )
L_check_response9:
	BTFSS       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_check_response10
;DHT11.c,96 :: 		counter++;
	INCF        check_response_counter_L0+0, 1 
;DHT11.c,97 :: 		Delay_us(1);
	MOVLW       3
	MOVWF       R13, 0
L_check_response11:
	DECFSZ      R13, 1, 1
	BRA         L_check_response11
	NOP
	NOP
;DHT11.c,98 :: 		if( counter == 80u )
	MOVF        check_response_counter_L0+0, 0 
	XORLW       80
	BTFSS       STATUS+0, 2 
	GOTO        L_check_response12
;DHT11.c,100 :: 		error = DHT11_NO_RESPONSE;
	MOVLW       1
	MOVWF       check_response_error_L0+0 
;DHT11.c,101 :: 		}
L_check_response12:
;DHT11.c,102 :: 		}
	GOTO        L_check_response9
L_check_response10:
;DHT11.c,103 :: 		if( error == DHT11_NO_ERROR )
	MOVF        check_response_error_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_check_response13
;DHT11.c,105 :: 		counter = 0u;
	CLRF        check_response_counter_L0+0 
;DHT11.c,107 :: 		while( !Data )
L_check_response14:
	BTFSC       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_check_response15
;DHT11.c,109 :: 		counter++;
	INCF        check_response_counter_L0+0, 1 
;DHT11.c,110 :: 		Delay_us(1);
	MOVLW       3
	MOVWF       R13, 0
L_check_response16:
	DECFSZ      R13, 1, 1
	BRA         L_check_response16
	NOP
	NOP
;DHT11.c,111 :: 		if( counter > 100u )
	MOVF        check_response_counter_L0+0, 0 
	SUBLW       100
	BTFSC       STATUS+0, 0 
	GOTO        L_check_response17
;DHT11.c,113 :: 		error = DHT11_NO_RESPONSE;
	MOVLW       1
	MOVWF       check_response_error_L0+0 
;DHT11.c,114 :: 		return error;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_check_response
;DHT11.c,115 :: 		}
L_check_response17:
;DHT11.c,116 :: 		}
	GOTO        L_check_response14
L_check_response15:
;DHT11.c,117 :: 		counter = 0;
	CLRF        check_response_counter_L0+0 
;DHT11.c,119 :: 		while( Data );
L_check_response18:
	BTFSS       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_check_response19
	GOTO        L_check_response18
L_check_response19:
;DHT11.c,121 :: 		counter++;
	INCF        check_response_counter_L0+0, 1 
;DHT11.c,122 :: 		Delay_us(1);
	MOVLW       3
	MOVWF       R13, 0
L_check_response20:
	DECFSZ      R13, 1, 1
	BRA         L_check_response20
	NOP
	NOP
;DHT11.c,123 :: 		if( counter > 100u )
	MOVF        check_response_counter_L0+0, 0 
	SUBLW       100
	BTFSC       STATUS+0, 0 
	GOTO        L_check_response21
;DHT11.c,125 :: 		error = DHT11_NO_RESPONSE;
	MOVLW       1
	MOVWF       check_response_error_L0+0 
;DHT11.c,126 :: 		return error;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_check_response
;DHT11.c,127 :: 		}
L_check_response21:
;DHT11.c,129 :: 		}
L_check_response13:
;DHT11.c,130 :: 		return error;
	MOVF        check_response_error_L0+0, 0 
	MOVWF       R0 
;DHT11.c,131 :: 		}
L_end_check_response:
	RETURN      0
; end of _check_response

_read_bytes:

;DHT11.c,133 :: 		uint8_t read_bytes( void )
;DHT11.c,135 :: 		uint8_t error = DHT11_NO_ERROR;
	CLRF        read_bytes_error_L0+0 
	CLRF        read_bytes_num_L0+0 
	CLRF        read_bytes_counter_L0+0 
;DHT11.c,139 :: 		DataDir = 1;
	BSF         TRISB2_bit+0, BitPos(TRISB2_bit+0) 
;DHT11.c,140 :: 		for( j=0; j<5u; j++ )
	CLRF        R3 
L_read_bytes22:
	MOVLW       5
	SUBWF       R3, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_read_bytes23
;DHT11.c,142 :: 		for( i=0; i<8u; i++ )
	CLRF        R2 
L_read_bytes25:
	MOVLW       8
	SUBWF       R2, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_read_bytes26
;DHT11.c,153 :: 		while( !Data )
L_read_bytes28:
	BTFSC       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_read_bytes29
;DHT11.c,155 :: 		counter++;
	INCF        read_bytes_counter_L0+0, 1 
;DHT11.c,156 :: 		Delay_us(1);
	MOVLW       3
	MOVWF       R13, 0
L_read_bytes30:
	DECFSZ      R13, 1, 1
	BRA         L_read_bytes30
	NOP
	NOP
;DHT11.c,157 :: 		if( counter > 80u )
	MOVF        read_bytes_counter_L0+0, 0 
	SUBLW       80
	BTFSC       STATUS+0, 0 
	GOTO        L_read_bytes31
;DHT11.c,159 :: 		error = DHT11_UNKNOWN;
	MOVLW       3
	MOVWF       read_bytes_error_L0+0 
;DHT11.c,160 :: 		}
L_read_bytes31:
;DHT11.c,161 :: 		}
	GOTO        L_read_bytes28
L_read_bytes29:
;DHT11.c,162 :: 		counter = 0;
	CLRF        read_bytes_counter_L0+0 
;DHT11.c,164 :: 		T1CON = 0x01;       // Start the Timer
	MOVLW       1
	MOVWF       T1CON+0 
;DHT11.c,166 :: 		while( Data )
L_read_bytes32:
	BTFSS       RB2_bit+0, BitPos(RB2_bit+0) 
	GOTO        L_read_bytes33
;DHT11.c,168 :: 		counter++;
	INCF        read_bytes_counter_L0+0, 1 
;DHT11.c,169 :: 		Delay_us(1);
	MOVLW       3
	MOVWF       R13, 0
L_read_bytes34:
	DECFSZ      R13, 1, 1
	BRA         L_read_bytes34
	NOP
	NOP
;DHT11.c,170 :: 		if( counter > 80u )
	MOVF        read_bytes_counter_L0+0, 0 
	SUBLW       80
	BTFSC       STATUS+0, 0 
	GOTO        L_read_bytes35
;DHT11.c,172 :: 		error = DHT11_UNKNOWN;
	MOVLW       3
	MOVWF       read_bytes_error_L0+0 
;DHT11.c,173 :: 		}
L_read_bytes35:
;DHT11.c,174 :: 		}
	GOTO        L_read_bytes32
L_read_bytes33:
;DHT11.c,175 :: 		counter = 0;
	CLRF        read_bytes_counter_L0+0 
;DHT11.c,176 :: 		T1CON = 0x00;       // Stop Timer and Check Counts
	CLRF        T1CON+0 
;DHT11.c,177 :: 		if( TOUT > 5u )     // Greater than 50us means 1
	MOVF        DHT11_TOUT+0, 0 
	SUBLW       5
	BTFSC       STATUS+0, 0 
	GOTO        L_read_bytes36
;DHT11.c,179 :: 		num |= 0x01<<(7-i);
	MOVF        R2, 0 
	SUBLW       7
	MOVWF       R0 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVLW       1
	MOVWF       R0 
	MOVF        R1, 0 
L__read_bytes46:
	BZ          L__read_bytes47
	RLCF        R0, 1 
	BCF         R0, 0 
	ADDLW       255
	GOTO        L__read_bytes46
L__read_bytes47:
	MOVF        R0, 0 
	IORWF       read_bytes_num_L0+0, 1 
;DHT11.c,180 :: 		}
	GOTO        L_read_bytes37
L_read_bytes36:
;DHT11.c,183 :: 		}
L_read_bytes37:
;DHT11.c,184 :: 		TOUT = 0x00;
	CLRF        DHT11_TOUT+0 
;DHT11.c,185 :: 		TMR1H = 0xFF;   // Load Values for 10us
	MOVLW       255
	MOVWF       TMR1H+0 
;DHT11.c,186 :: 		TMR1L        = 0x88;
	MOVLW       136
	MOVWF       TMR1L+0 
;DHT11.c,142 :: 		for( i=0; i<8u; i++ )
	INCF        R2, 1 
;DHT11.c,187 :: 		}
	GOTO        L_read_bytes25
L_read_bytes26:
;DHT11.c,188 :: 		temp[j] = num;
	MOVLW       DHT11_temp+0
	MOVWF       FSR1 
	MOVLW       hi_addr(DHT11_temp+0)
	MOVWF       FSR1H 
	MOVF        R3, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        read_bytes_num_L0+0, 0 
	MOVWF       POSTINC1+0 
;DHT11.c,189 :: 		num = 0u;
	CLRF        read_bytes_num_L0+0 
;DHT11.c,140 :: 		for( j=0; j<5u; j++ )
	INCF        R3, 1 
;DHT11.c,190 :: 		}
	GOTO        L_read_bytes22
L_read_bytes23:
;DHT11.c,191 :: 		return error;
	MOVF        read_bytes_error_L0+0, 0 
	MOVWF       R0 
;DHT11.c,192 :: 		}
L_end_read_bytes:
	RETURN      0
; end of _read_bytes
