#line 1 "D:/Dropbox/Projects/Microchip/DHT11_OLED/DHT11/DHT11.c"
#line 1 "d:/dropbox/projects/microchip/dht11_oled/dht11/dht11.h"
#line 1 "c:/program files (x86)/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 12 "d:/dropbox/projects/microchip/dht11_oled/dht11/dht11.h"
void dht11_init( void );
uint8_t dht11_start_measurement( void );
uint8_t dht11_temperature( void );
uint8_t dht11_humidity( void );
void dht11_int_handler( void );
#line 3 "D:/Dropbox/Projects/Microchip/DHT11_OLED/DHT11/DHT11.c"
sbit Data at RB2_bit;
sbit DataDir at TRISB2_bit;

static uint8_t TOUT = 0;
static uint8_t temperature;
static uint8_t humidity;
static uint8_t temp[5];


void start_signal( void );
uint8_t check_response( void );
uint8_t read_bytes( void );


void dht11_init( void )
{
 TOUT = 0;
 T1CON = 0x00;
 TMR1IF_bit = 0;
 TMR1H = 0xFF;
 TMR1L = 0x88;
 TMR1IE_bit = 1;
 INTCON = 0xC0;
}

void dht11_int_handler( void )
{
 TMR1IF_bit = 0;
 TMR1H = 0xFF;
 TMR1L = 0x88;
 TOUT++;
}

uint8_t dht11_start_measurement( void )
{
 uint8_t error =  0u ;
 uint8_t i, check, checksum;
 start_signal();
 check = check_response();
 if( check !=  0u  )
 {
 error =  1u ;
 UART1_Write_Text("Response Error\r\n");
 }
 else
 {
 checksum = 0;
 error = read_bytes();
 for( i=0; i<4; i++ )
 {
 checksum = checksum + temp[i];
 }
 if( checksum == temp[4] )
 {

 humidity = temp[0];
 temperature = temp[2];
 }
 else
 {
 error =  2u ;
 }
 }
 return error;
}

uint8_t dht11_temperature( void )
{
 return temperature;
}

uint8_t dht11_humidity( void )
{
 return humidity;
}

void start_signal( void )
{
 DataDir = 0;
 Data = 0;
 Delay_ms(25);
 Data = 1;
 Delay_us(30);
 DataDir = 1;
}

uint8_t check_response( void )
{
 uint8_t error =  0u ;
 uint8_t counter = 0u;

 while( Data )
 {
 counter++;
 Delay_us(1);
 if( counter == 80u )
 {
 error =  1u ;
 }
 }
 if( error ==  0u  )
 {
 counter = 0u;

 while( !Data )
 {
 counter++;
 Delay_us(1);
 if( counter > 100u )
 {
 error =  1u ;
 return error;
 }
 }
 counter = 0;

 while( Data );
 {
 counter++;
 Delay_us(1);
 if( counter > 100u )
 {
 error =  1u ;
 return error;
 }
 }
 }
 return error;
}

uint8_t read_bytes( void )
{
 uint8_t error =  0u ;
 uint8_t num = 0;
 uint8_t i, j;
 uint8_t counter = 0;
 DataDir = 1;
 for( j=0; j<5u; j++ )
 {
 for( i=0; i<8u; i++ )
 {
#line 153 "D:/Dropbox/Projects/Microchip/DHT11_OLED/DHT11/DHT11.c"
 while( !Data )
 {
 counter++;
 Delay_us(1);
 if( counter > 80u )
 {
 error =  3u ;
 }
 }
 counter = 0;

 T1CON = 0x01;

 while( Data )
 {
 counter++;
 Delay_us(1);
 if( counter > 80u )
 {
 error =  3u ;
 }
 }
 counter = 0;
 T1CON = 0x00;
 if( TOUT > 5u )
 {
 num |= 0x01<<(7-i);
 }
 else
 {
 }
 TOUT = 0x00;
 TMR1H = 0xFF;
 TMR1L = 0x88;
 }
 temp[j] = num;
 num = 0u;
 }
 return error;
}
