
_interrupt:

;main.c,20 :: 		void interrupt() iv 0x0008
;main.c,22 :: 		if( TMR1IF_bit )
	BTFSS       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L_interrupt0
;main.c,24 :: 		dht11_int_handler();
	CALL        _dht11_int_handler+0, 0
;main.c,25 :: 		}
L_interrupt0:
;main.c,26 :: 		}
L_end_interrupt:
L__interrupt13:
	RETFIE      1
; end of _interrupt

_main:

;main.c,28 :: 		void main()
;main.c,33 :: 		UART1_Init(9600);
	BSF         BAUDCON+0, 3, 0
	MOVLW       4
	MOVWF       SPBRGH+0 
	MOVLW       225
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;main.c,34 :: 		OLED_Init();
	CALL        _OLED_Init+0, 0
;main.c,35 :: 		dht11_init();
	CALL        _dht11_init+0, 0
;main.c,36 :: 		OLED_ClearDisplay();
	CALL        _OLED_ClearDisplay+0, 0
;main.c,37 :: 		OLED_Image( DHT11_Image );
	MOVLW       _DHT11_Image+0
	MOVWF       FARG_OLED_Image_image+0 
	MOVLW       hi_addr(_DHT11_Image+0)
	MOVWF       FARG_OLED_Image_image+1 
	MOVLW       higher_addr(_DHT11_Image+0)
	MOVWF       FARG_OLED_Image_image+2 
	CALL        _OLED_Image+0, 0
;main.c,38 :: 		OLED_Update();
	CALL        _OLED_Update+0, 0
;main.c,40 :: 		Delay_ms(2000);
	MOVLW       122
	MOVWF       R11, 0
	MOVLW       193
	MOVWF       R12, 0
	MOVLW       129
	MOVWF       R13, 0
L_main1:
	DECFSZ      R13, 1, 1
	BRA         L_main1
	DECFSZ      R12, 1, 1
	BRA         L_main1
	DECFSZ      R11, 1, 1
	BRA         L_main1
	NOP
	NOP
;main.c,41 :: 		while(1)
L_main2:
;main.c,43 :: 		error = dht11_start_measurement();
	CALL        _dht11_start_measurement+0, 0
	MOVF        R0, 0 
	MOVWF       main_error_L0+0 
;main.c,44 :: 		if( error == DHT11_NO_ERROR )
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_main4
;main.c,49 :: 		OLED_ClearDisplay();
	CALL        _OLED_ClearDisplay+0, 0
;main.c,51 :: 		temperature = dht11_temperature();
	CALL        _dht11_temperature+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__main+0 
	MOVF        FLOC__main+0, 0 
	MOVWF       main_temperature_L0+0 
;main.c,52 :: 		temperature_text[0] = temperature/10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        FLOC__main+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVLW       48
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       main_temperature_text_L0+0 
;main.c,53 :: 		temperature_text[1] = temperature%10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        FLOC__main+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       main_temperature_text_L0+1 
;main.c,54 :: 		temperature_text[2] = ' ';
	MOVLW       32
	MOVWF       main_temperature_text_L0+2 
;main.c,55 :: 		temperature_text[3] = 'C';
	MOVLW       67
	MOVWF       main_temperature_text_L0+3 
;main.c,56 :: 		temperature_text[4] = 0;  // Null Character
	CLRF        main_temperature_text_L0+4 
;main.c,58 :: 		x = OLED_Width()-(8*4);
	CALL        _OLED_Width+0, 0
	MOVLW       0
	MOVWF       R1 
	MOVLW       32
	SUBWF       R0, 1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       main_x_L2+0 
	MOVF        R1, 0 
	MOVWF       main_x_L2+1 
;main.c,59 :: 		OLED_Rectangle( 0, 0, x, 7, WHITE );
	CLRF        FARG_OLED_Rectangle_x1+0 
	CLRF        FARG_OLED_Rectangle_y1+0 
	MOVF        R0, 0 
	MOVWF       FARG_OLED_Rectangle_x2+0 
	MOVLW       7
	MOVWF       FARG_OLED_Rectangle_y2+0 
	MOVLW       1
	MOVWF       FARG_OLED_Rectangle_color+0 
	CALL        _OLED_Rectangle+0, 0
;main.c,60 :: 		percentage = temperature * 100;
	MOVLW       100
	MULWF       main_temperature_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       R0 
	MOVF        PRODH+0, 0 
	MOVWF       R1 
;main.c,61 :: 		percentage = percentage/(MAX_TEMPERATURE - MIN_TEMPERATURE );
	MOVLW       50
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
;main.c,62 :: 		x = percentage * x /100;
	MOVF        main_x_L2+0, 0 
	MOVWF       R4 
	MOVF        main_x_L2+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       main_x_L2+0 
	MOVF        R1, 0 
	MOVWF       main_x_L2+1 
;main.c,63 :: 		OLED_FillRectangle( 0, 0, x, 7, WHITE );
	CLRF        FARG_OLED_FillRectangle_x1+0 
	CLRF        FARG_OLED_FillRectangle_y1+0 
	MOVF        R0, 0 
	MOVWF       FARG_OLED_FillRectangle_x2+0 
	MOVLW       7
	MOVWF       FARG_OLED_FillRectangle_y2+0 
	MOVLW       1
	MOVWF       FARG_OLED_FillRectangle_color+0 
	CALL        _OLED_FillRectangle+0, 0
;main.c,64 :: 		OLED_Write_Text( OLED_Width()-(8*3), 0, temperature_text );
	CALL        _OLED_Width+0, 0
	MOVLW       24
	SUBWF       R0, 0 
	MOVWF       FARG_OLED_Write_Text_x+0 
	CLRF        FARG_OLED_Write_Text_y+0 
	MOVLW       main_temperature_text_L0+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(main_temperature_text_L0+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,66 :: 		humidity = dht11_humidity();
	CALL        _dht11_humidity+0, 0
	MOVF        R0, 0 
	MOVWF       FLOC__main+0 
	MOVF        FLOC__main+0, 0 
	MOVWF       main_humidity_L0+0 
;main.c,67 :: 		humidity_text[0] = humidity/10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        FLOC__main+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVLW       48
	ADDWF       R0, 1 
	MOVF        R0, 0 
	MOVWF       main_humidity_text_L0+0 
;main.c,68 :: 		humidity_text[1] = humidity%10 + 48;
	MOVLW       10
	MOVWF       R4 
	MOVF        FLOC__main+0, 0 
	MOVWF       R0 
	CALL        _Div_8X8_U+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVLW       48
	ADDWF       R0, 0 
	MOVWF       main_humidity_text_L0+1 
;main.c,69 :: 		humidity_text[2] = ' ';
	MOVLW       32
	MOVWF       main_humidity_text_L0+2 
;main.c,70 :: 		humidity_text[3] = '%';
	MOVLW       37
	MOVWF       main_humidity_text_L0+3 
;main.c,71 :: 		humidity_text[4] = 0;   // Null Character
	CLRF        main_humidity_text_L0+4 
;main.c,72 :: 		x = OLED_Width()-(8*4);
	CALL        _OLED_Width+0, 0
	MOVLW       0
	MOVWF       R1 
	MOVLW       32
	SUBWF       R0, 1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       main_x_L2+0 
	MOVF        R1, 0 
	MOVWF       main_x_L2+1 
;main.c,73 :: 		OLED_Rectangle( 0, 15, x, 23, WHITE );
	CLRF        FARG_OLED_Rectangle_x1+0 
	MOVLW       15
	MOVWF       FARG_OLED_Rectangle_y1+0 
	MOVF        R0, 0 
	MOVWF       FARG_OLED_Rectangle_x2+0 
	MOVLW       23
	MOVWF       FARG_OLED_Rectangle_y2+0 
	MOVLW       1
	MOVWF       FARG_OLED_Rectangle_color+0 
	CALL        _OLED_Rectangle+0, 0
;main.c,74 :: 		percentage = humidity * 100;
	MOVLW       100
	MULWF       main_humidity_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       R0 
	MOVF        PRODH+0, 0 
	MOVWF       R1 
;main.c,75 :: 		percentage = percentage/(MAX_HUMIDITY - MIN_HUMIDITY );
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
;main.c,76 :: 		x = percentage * x /100;
	MOVF        main_x_L2+0, 0 
	MOVWF       R4 
	MOVF        main_x_L2+1, 0 
	MOVWF       R5 
	CALL        _Mul_16X16_U+0, 0
	MOVLW       100
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	CALL        _Div_16X16_U+0, 0
	MOVF        R0, 0 
	MOVWF       main_x_L2+0 
	MOVF        R1, 0 
	MOVWF       main_x_L2+1 
;main.c,77 :: 		OLED_FillRectangle( 0, 15, x, 23, WHITE );
	CLRF        FARG_OLED_FillRectangle_x1+0 
	MOVLW       15
	MOVWF       FARG_OLED_FillRectangle_y1+0 
	MOVF        R0, 0 
	MOVWF       FARG_OLED_FillRectangle_x2+0 
	MOVLW       23
	MOVWF       FARG_OLED_FillRectangle_y2+0 
	MOVLW       1
	MOVWF       FARG_OLED_FillRectangle_color+0 
	CALL        _OLED_FillRectangle+0, 0
;main.c,78 :: 		OLED_Write_Text( OLED_Width()-(8*3), 15, humidity_text );
	CALL        _OLED_Width+0, 0
	MOVLW       24
	SUBWF       R0, 0 
	MOVWF       FARG_OLED_Write_Text_x+0 
	MOVLW       15
	MOVWF       FARG_OLED_Write_Text_y+0 
	MOVLW       main_humidity_text_L0+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(main_humidity_text_L0+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,80 :: 		OLED_Write_Text( 0, 25, "Sensor: OK");
	CLRF        FARG_OLED_Write_Text_x+0 
	MOVLW       25
	MOVWF       FARG_OLED_Write_Text_y+0 
	MOVLW       ?lstr1_main+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(?lstr1_main+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,81 :: 		OLED_Update();
	CALL        _OLED_Update+0, 0
;main.c,91 :: 		}
	GOTO        L_main5
L_main4:
;main.c,94 :: 		UART1_Write_Text("DHT11 Not Connected");
	MOVLW       ?lstr2_main+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr2_main+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;main.c,95 :: 		switch(error)
	GOTO        L_main6
;main.c,97 :: 		case DHT11_NO_RESPONSE:
L_main8:
;main.c,98 :: 		OLED_Write_Text( 0, 25, "Sensor: No Response");
	CLRF        FARG_OLED_Write_Text_x+0 
	MOVLW       25
	MOVWF       FARG_OLED_Write_Text_y+0 
	MOVLW       ?lstr3_main+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(?lstr3_main+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,99 :: 		break;
	GOTO        L_main7
;main.c,100 :: 		case DHT11_CHECKSUM_ERROR:
L_main9:
;main.c,101 :: 		OLED_Write_Text( 0, 25, "Sensor: Checksum Error");
	CLRF        FARG_OLED_Write_Text_x+0 
	MOVLW       25
	MOVWF       FARG_OLED_Write_Text_y+0 
	MOVLW       ?lstr4_main+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(?lstr4_main+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,102 :: 		break;
	GOTO        L_main7
;main.c,103 :: 		default:
L_main10:
;main.c,104 :: 		OLED_Write_Text( 0, 25, "Sensor: Unknown Error");
	CLRF        FARG_OLED_Write_Text_x+0 
	MOVLW       25
	MOVWF       FARG_OLED_Write_Text_y+0 
	MOVLW       ?lstr5_main+0
	MOVWF       FARG_OLED_Write_Text_text+0 
	MOVLW       hi_addr(?lstr5_main+0)
	MOVWF       FARG_OLED_Write_Text_text+1 
	CALL        _OLED_Write_Text+0, 0
;main.c,105 :: 		break;
	GOTO        L_main7
;main.c,106 :: 		};
L_main6:
	MOVF        main_error_L0+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	MOVF        main_error_L0+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_main9
	GOTO        L_main10
L_main7:
;main.c,107 :: 		OLED_Update();
	CALL        _OLED_Update+0, 0
;main.c,108 :: 		}
L_main5:
;main.c,109 :: 		Delay_ms(1000);
	MOVLW       61
	MOVWF       R11, 0
	MOVLW       225
	MOVWF       R12, 0
	MOVLW       63
	MOVWF       R13, 0
L_main11:
	DECFSZ      R13, 1, 1
	BRA         L_main11
	DECFSZ      R12, 1, 1
	BRA         L_main11
	DECFSZ      R11, 1, 1
	BRA         L_main11
	NOP
	NOP
;main.c,110 :: 		}
	GOTO        L_main2
;main.c,111 :: 		}
L_end_main:
	GOTO        $+0
; end of _main
